package org.dromara.biz.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.system.domain.vo.SysUserVo;
import org.dromara.system.service.ISysUserService;
import org.springframework.stereotype.Service;
import org.dromara.biz.domain.bo.BizTaskLogBo;
import org.dromara.biz.domain.vo.BizTaskLogVo;
import org.dromara.biz.domain.BizTaskLog;
import org.dromara.biz.mapper.BizTaskLogMapper;
import org.dromara.biz.service.IBizTaskLogService;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * 任务日志Service业务层处理
 *
 * @author chenle
 * @date 2025-05-19
 */
@RequiredArgsConstructor
@Service
public class BizTaskLogServiceImpl implements IBizTaskLogService {

    private final BizTaskLogMapper baseMapper;
    private final ISysUserService sysUserService;

    /**
     * 查询任务日志
     *
     * @param id 主键
     * @return 任务日志
     */
    @Override
    public BizTaskLogVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询任务日志列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 任务日志分页列表
     */
    @Override
    public TableDataInfo<BizTaskLogVo> queryPageList(BizTaskLogBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<BizTaskLog> lqw = buildQueryWrapper(bo);
        Page<BizTaskLogVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的任务日志列表
     *
     * @param bo 查询条件
     * @return 任务日志列表
     */
    @Override
    public List<BizTaskLogVo> queryList(BizTaskLogBo bo) {
        LambdaQueryWrapper<BizTaskLog> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<BizTaskLog> buildQueryWrapper(BizTaskLogBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<BizTaskLog> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(BizTaskLog::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getTaskNo()), BizTaskLog::getTaskNo, bo.getTaskNo());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), BizTaskLog::getType, bo.getType());
        lqw.eq(bo.getUserId() != null, BizTaskLog::getUserId, bo.getUserId());
        lqw.like(StringUtils.isNotBlank(bo.getUserName()), BizTaskLog::getUserName, bo.getUserName());
        lqw.eq(StringUtils.isNotBlank(bo.getDeptId()), BizTaskLog::getDeptId, bo.getDeptId());
        lqw.like(StringUtils.isNotBlank(bo.getDeptName()), BizTaskLog::getDeptName, bo.getDeptName());
        lqw.eq(bo.getOptime() != null, BizTaskLog::getOptime, bo.getOptime());
        lqw.eq(StringUtils.isNotBlank(bo.getOpip()), BizTaskLog::getOpip, bo.getOpip());
        lqw.eq(StringUtils.isNotBlank(bo.getRelationId()), BizTaskLog::getRelationId, bo.getRelationId());
        return lqw;
    }

    /**
     * 新增任务日志
     *
     * @param bo 任务日志
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(BizTaskLogBo bo) {
        BizTaskLog add = MapstructUtils.convert(bo, BizTaskLog.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改任务日志
     *
     * @param bo 任务日志
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(BizTaskLogBo bo) {
        BizTaskLog update = MapstructUtils.convert(bo, BizTaskLog.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(BizTaskLog entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除任务日志信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Transactional
    @Override
    public Boolean saveToBizTaskLog(String instanceId, String userId, String type, String remark,String imageUrl,String fileUrl) {
        BizTaskLogBo bizTaskLogBo = new BizTaskLogBo();
        bizTaskLogBo.setOptime(new Date());
        bizTaskLogBo.setRelationId(instanceId);
        bizTaskLogBo.setTaskNo(instanceId);
        SysUserVo sysUserVo = sysUserService.selectUserById(Long.valueOf(userId));
        if(!Objects.isNull(sysUserVo)){
            bizTaskLogBo.setPoliceNum(sysUserVo.getUserName());
            bizTaskLogBo.setUserName(sysUserVo.getNickName());
            bizTaskLogBo.setDeptId(String.valueOf(sysUserVo.getDeptId()));
            bizTaskLogBo.setDeptName(sysUserVo.getDeptName());
        }
        bizTaskLogBo.setUserId(Long.valueOf(userId));

        bizTaskLogBo.setRemark(remark);
        bizTaskLogBo.setType(type);
        if(StringUtils.isNotBlank(imageUrl)){
            bizTaskLogBo.setImageUrl(imageUrl);
        }
        if(StringUtils.isNotBlank(fileUrl)){
            bizTaskLogBo.setFileUrl(fileUrl);
        }
        BizTaskLog add = MapstructUtils.convert(bizTaskLogBo, BizTaskLog.class);
        return baseMapper.insert(add) > 0;
    }
}
